/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAnalytics4ControllerActionMetricRequestValue type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAnalytics4ControllerActionMetricRequestValue{}

// GoogleAnalytics4ControllerActionMetricRequestValue struct for GoogleAnalytics4ControllerActionMetricRequestValue
type GoogleAnalytics4ControllerActionMetricRequestValue struct {
	OAuthId    *string `json:"oAuthId,omitempty"`
	PropertyId *string `json:"propertyId,omitempty"`
}

// NewGoogleAnalytics4ControllerActionMetricRequestValue instantiates a new GoogleAnalytics4ControllerActionMetricRequestValue object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAnalytics4ControllerActionMetricRequestValue() *GoogleAnalytics4ControllerActionMetricRequestValue {
	this := GoogleAnalytics4ControllerActionMetricRequestValue{}
	return &this
}

// NewGoogleAnalytics4ControllerActionMetricRequestValueWithDefaults instantiates a new GoogleAnalytics4ControllerActionMetricRequestValue object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAnalytics4ControllerActionMetricRequestValueWithDefaults() *GoogleAnalytics4ControllerActionMetricRequestValue {
	this := GoogleAnalytics4ControllerActionMetricRequestValue{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ControllerActionMetricRequestValue) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ControllerActionMetricRequestValue) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ControllerActionMetricRequestValue) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleAnalytics4ControllerActionMetricRequestValue) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetPropertyId returns the PropertyId field value if set, zero value otherwise.
func (o *GoogleAnalytics4ControllerActionMetricRequestValue) GetPropertyId() string {
	if o == nil || IsNil(o.PropertyId) {
		var ret string
		return ret
	}
	return *o.PropertyId
}

// GetPropertyIdOk returns a tuple with the PropertyId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAnalytics4ControllerActionMetricRequestValue) GetPropertyIdOk() (*string, bool) {
	if o == nil || IsNil(o.PropertyId) {
		return nil, false
	}
	return o.PropertyId, true
}

// HasPropertyId returns a boolean if a field has been set.
func (o *GoogleAnalytics4ControllerActionMetricRequestValue) HasPropertyId() bool {
	if o != nil && !IsNil(o.PropertyId) {
		return true
	}

	return false
}

// SetPropertyId gets a reference to the given string and assigns it to the PropertyId field.
func (o *GoogleAnalytics4ControllerActionMetricRequestValue) SetPropertyId(v string) {
	o.PropertyId = &v
}

func (o GoogleAnalytics4ControllerActionMetricRequestValue) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAnalytics4ControllerActionMetricRequestValue) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.PropertyId) {
		toSerialize["propertyId"] = o.PropertyId
	}
	return toSerialize, nil
}

type NullableGoogleAnalytics4ControllerActionMetricRequestValue struct {
	value *GoogleAnalytics4ControllerActionMetricRequestValue
	isSet bool
}

func (v NullableGoogleAnalytics4ControllerActionMetricRequestValue) Get() *GoogleAnalytics4ControllerActionMetricRequestValue {
	return v.value
}

func (v *NullableGoogleAnalytics4ControllerActionMetricRequestValue) Set(val *GoogleAnalytics4ControllerActionMetricRequestValue) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAnalytics4ControllerActionMetricRequestValue) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAnalytics4ControllerActionMetricRequestValue) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAnalytics4ControllerActionMetricRequestValue(val *GoogleAnalytics4ControllerActionMetricRequestValue) *NullableGoogleAnalytics4ControllerActionMetricRequestValue {
	return &NullableGoogleAnalytics4ControllerActionMetricRequestValue{value: val, isSet: true}
}

func (v NullableGoogleAnalytics4ControllerActionMetricRequestValue) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAnalytics4ControllerActionMetricRequestValue) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
